use vars qw(@ISA @EXPORT);
use Exporter;

@ISA = qw(Exporter);
@EXPORT = qw(check_smtp check_sshd check_ftpd check_pop2 check_pop3 check_imap2 check_imap3 check_nntp check_snpp);

sub check_smtp {
  my $dest = shift;

  my ($line, $smtp);
  my ($smtp_banner, $smtp_vrfy, $smtp_expn);

  open(FILE, "log/scan-$dest.log") || print "Can't open logfile(log/scan-$dest.log) because: $!\n";
  while($line = <FILE>) {
    if ($line =~ /^25\/tcp.*open/) { 
      $smtp = 1;
    }
  }
  close(FILE);

  if ($smtp == 1) {
    print "  - smtp banner check, write to logfile log/smtp-$dest.log\n";

    my $remote = open_socket(25, $dest, "tcp");
  
    print $remote "QUIT\n";
    $smtp_banner = <$remote>;
    close($remote);

    $remote = open_socket(25, $dest, "tcp");

    print $remote "HELP\nQUIT\n";
    while (<$remote>) {
      if (/EXPN/) {
        $smtp_expn = 1;
      }
      if (/VRFY/) {
        $smtp_vrfy = 1;
      }
    }
    close($remote);

    open (FILE, "> log/smtp-$dest.log") or print "Can't open logfile(log/smtp-$dest.log) because : $!\n";
    print FILE "Banner: $smtp_banner\n";
    print FILE "EXPN is ";
    if ($smtp_expn == 1) {
     print FILE "enabled.\n";
    } 
    else {
      print FILE "disabled.\n";
    }
    print FILE "VRFY is ";
    if ($smtp_vrfy == 1) {
      print FILE "enabled.\n";
    }
    else {
      print FILE "disabled.\n";
    }
    close(FILE);  

    print "  - smtp banner check complete\n";
  }
}

sub check_sshd {
  my $dest = shift;

  my ($line, $ssh);
  my ($sshd_banner);

  open(FILE, "log/scan-$dest.log") || print "Can't open logfile(log/scan-$dest.log) because: $!\n";
  while($line = <FILE>) {
    if ($line =~ /^22\/tcp.*open/) { 
      $ssh = 1;
    }
  }
  close(FILE);

  if ($ssh == 1) {
    print "  - sshd banner check, write to logfile log/sshd-$dest.log\n";

    my $remote = open_socket(22, $dest, "tcp");
  
    $sshd_banner = <$remote>;
    close($remote);

    open (FILE, "> log/sshd-$dest.log") or print "Can't open logfile(log/sshd-$dest.log) because : $!\n";
    print FILE "Banner: $sshd_banner\n";
    close(FILE);  

    print "  - sshd banner check complete\n";
  }
}

sub check_ftpd {
  my $dest = shift;

  my ($line, $ftp);
  my ($ftpd_banner, $anonymous);

  open(FILE, "log/scan-$dest.log") || print "Can't open logfile(log/scan-$dest.log) because: $!\n";
  while($line = <FILE>) {
    if ($line =~ /^21\/tcp.*open/) { 
      $ftp = 1;
    }
  }
  close(FILE);

  if ($ftp == 1) {
    print "  - ftpd banner check, write to logfile log/ftpd-$dest.log\n";

    my $remote = open_socket(21, $dest, "tcp");
  
    print $remote "quit\n";
    $ftpd_banner = <$remote>;
    close($remote);

    $remote = open_socket(21, $dest, "tcp");

    print $remote "user $ftp_user\n";
    print $remote "pass $ftp_password\n";
    print $remote "quit\n";
    while (<$remote>) {
      if (/230/) {
        $anonymous = 1;
      }
      elsif (/530/) {
        $anonymous = 0;
      }
    }
    close($remote);

    open (FILE, "> log/ftpd-$dest.log") or print "Can't open logfile(log/ftpd-$dest.log) because : $!\n";
    print FILE "Banner: $ftpd_banner\n";
    print FILE "Anonymous login is ";
    if ($anonymous == 1) {
     print FILE "enabled.\n";
    } 
    else {
      print FILE "disabled.\n";
    }
    close(FILE);  

    print "  - ftpd banner check complete\n";
  }
}

sub check_pop2 {
  my $dest = shift;

  my ($line, $pop2);
  my ($pop2d_banner);

  open(FILE, "log/scan-$dest.log") || print "Can't open logfile(log/scan-$dest.log) because: $!\n";
  while($line = <FILE>) {
    if ($line =~ /^109\/tcp.*open/) { 
      $pop2 = 1;
    }
  }
  close(FILE);

  if ($pop2 == 1) {
    print "  - pop2d banner check, write to logfile log/pop2d-$dest.log\n";

    my $remote = open_socket(109, $dest, "tcp");
  
    $pop2d_banner = <$remote>;
    close($remote);

    open (FILE, "> log/pop2d-$dest.log") or print "Can't open logfile(log/pop2d-$dest.log) because : $!\n";
    print FILE "Banner: $pop2d_banner\n";
    close(FILE);  

    print "  - pop2d banner check complete\n";
  }
}

sub check_pop3 {
  my $dest = shift;

  my ($line, $pop3);
  my ($pop3d_banner);

  open(FILE, "log/scan-$dest.log") || print "Can't open logfile(log/scan-$dest.log) because: $!\n";
  while($line = <FILE>) {
    if ($line =~ /^110\/tcp.*open/) { 
      $pop3 = 1;
    }
  }
  close(FILE);

  if ($pop3 == 1) {
    print "  - pop3d banner check, write to logfile log/pop2d-$dest.log\n";

    my $remote = open_socket(110, $dest, "tcp");
  
    $pop3d_banner = <$remote>;
    close($remote);

    open (FILE, "> log/pop3d-$dest.log") or print "Can't open logfile(log/pop3d-$dest.log) because : $!\n";
    print FILE "Banner: $pop3d_banner\n";
    close(FILE);  

    print "  - pop3d banner check complete\n";
  }
}

sub check_imap2 {
  my $dest = shift;

  my ($line, $imap);
  my ($imapd_banner);

  open(FILE, "log/scan-$dest.log") || print "Can't open logfile(log/scan-$dest.log) because: $!\n";
  while($line = <FILE>) {
    if ($line =~ /^143\/tcp.*open/) { 
      $imap = 1;
    }
  }
  close(FILE);

  if ($imap == 1) {
    print "  - imapdv2 banner check, write to logfile log/imapdv2-$dest.log\n";

    my $remote = open_socket(143, $dest, "tcp");
  
    $imapd_banner = <$remote>;
    close($remote);
 
    open (FILE, "> log/imapdv2-$dest.log") or print "Can't open logfile(log/imapdv2-$dest.log) because : $!\n";
    print FILE "Banner: $imapd_banner\n";
    close(FILE);  

    print "  - imapdv2 banner check complete\n";
  }
}

sub check_imap3 {
  my $dest = shift;

  my ($line, $imap);
  my ($imapd_banner);

  open(FILE, "log/scan-$dest.log") || print "Can't open logfile(log/scan-$dest.log) because: $!\n";
  while($line = <FILE>) {
    if ($line =~ /^220\/tcp.*open/) { 
      $imap = 1;
    }
  }
  close(FILE);

  if ($imap == 1) {
    print "  - imapdv3 banner check, write to logfile log/imapdv3-$dest.log\n";

    my $remote = open_socket(220, $dest, "tcp");
  
    $imapd_banner = <$remote>;
    close($remote);
 
    open (FILE, "> log/imapdv3-$dest.log") or print "Can't open logfile(log/imapdv3-$dest.log) because : $!\n";
    print FILE "Banner: $imapd_banner\n";
    close(FILE);  

    print "  - imapdv3 banner check complete\n";
  }
}

sub check_nntp {
  my $dest = shift;

  my ($line, $nntp);
  my ($nntp_banner);

  open(FILE, "log/scan-$dest.log") || print "Can't open logfile(log/scan-$dest.log) because: $!\n";
  while($line = <FILE>) {
    if ($line =~ /^119\/tcp.*open/) { 
      $nntp = 1;
    }
  }
  close(FILE);

  if ($nntp == 1) {
    print "  - nntp banner check, write to logfile log/nntp-$dest.log\n";

    my $remote = open_socket(119, $dest, "tcp");
  
    $nntp_banner = <$remote>;
    close($remote);
 
    open (FILE, "> log/nntp-$dest.log") or print "Can't open logfile(log/nntp-$dest.log) because : $!\n";
    print FILE "Banner: $nntp_banner\n";
    close(FILE);  

    print "  - nntp banner check complete\n";
  }
}

sub check_snpp {
  my $dest = shift;

  my ($line, $snpp);
  my ($snpp_banner);

  open(FILE, "log/scan-$dest.log") || print "Can't open logfile(log/scan-$dest.log) because: $!\n";
  while($line = <FILE>) {
    if ($line =~ /^444\/tcp.*open/) { 
      $snpp = 1;
    }
  }
  close(FILE);

  if ($snpp == 1) {
    print "  - snpp banner check, write to logfile log/snpp-$dest.log\n";

    my $remote = open_socket(444, $dest, "tcp");
  
    $snpp_banner = <$remote>;
    close($remote);
 
    open (FILE, "> log/snpp-$dest.log") or print "Can't open logfile(log/snpp-$dest.log) because : $!\n";
    print FILE "Banner: $snpp_banner\n";
    close(FILE);  

    print "  - snpp banner check complete\n";
  }
}

1;
